# -*- coding:Utf-8 -*-
import es, playerlib, langlib, sqlite3, popuplib
import sw_config as swConfig
import sw_player as swPlayer

## Ouverture du fichier de langue
sw_langue = langlib.Strings(es.getAddonPath("sorrow") + "/configuration/langues.ini")

class Ghost:
    def __init__(self, userid):
        self.userid = userid
        self.steamid = es.getplayersteamid(userid)
        self.create_menu() # Créer le menu
    def ghost(self):
        joueur = playerlib.getPlayer(self.userid) # instantiation du joueur
        config = swConfig.Config("modules") # Récupération des configurations du module ghost dans le fichier modules.ini
        ghost_red = config.get("ModuleGhoster", "ghost_red")
        ghost_blue = config.get("ModuleGhoster", "ghost_blue")
        ghost_green = config.get("ModuleGhoster", "ghost_green")
        ghost_alpha = config.get("ModuleGhoster", "ghost_alpha")
        joueur.set("color", [ ghost_red, ghost_green, ghost_blue, ghost_alpha ]) # Change la couleur du joueur
        es.setplayerprop(self.userid,"CBaseEntity.m_CollisionGroup", '2') # Change les prop du joueur pour que l'on puisse passer à travers lui
        player = swPlayer.Player(self.userid) # Instantiation du joueur dans le module player
        player.set("isghost", 1) # Change la valeur de isghost pour informer la base de donnée qu'il est ghost
        es.tell(self.userid,"#multi",sw_langue("ghost",lang=joueur.get("lang"))) # Envoi d'un message au joueur
        return True # Je me rapelle pas de l'utilié ? :p
    def unghost(self):
        joueur = playerlib.getPlayer(self.userid)
        joueur.set("color", [ "255", "255", "255", "255" ]) # Remet les couleurs du joueur par defaut
        es.setplayerprop(self.userid,"CBaseEntity.m_CollisionGroup", '5') # Rechange ces props
        player = swPlayer.Player(self.userid)
        player.set("isghost", 0) # Informe la base de donnée qu'il n'est plus ghost
        es.tell(self.userid,"#multi",sw_langue("unghost",lang=joueur.get("lang"))) # Envoi d'un message
        return True # Aucune utilité encore ?
    def create_menu(self):
        menugh = popuplib.create('menuGhoster') # Ici je créer le menu
        menugh.addline("(      [Sorrow]      )")
        menugh.addline("------ Menu Ghoster ------")
        menugh.addline("->1. Ghost")
        menugh.addline("->2. UnGhost")
        menugh.addline("------------------")
        menugh.addline("->8. Retour")
        menugh.addline("->0. Sortir")
        menugh.menuselect = self.choix_menu
    def choix_menu(self, userid, choix, popupid):
        config = swConfig.Config("modules") # Récupére les configs du module ghost dans le fichier modules.ini
        ghost_level = config.get("ModuleGhoster", "ghost_level")
        unghost_level = config.get("ModuleGhoster", "unghost_level")
        player = swPlayer.Player(self.userid) # Instation du joueur dans le module player pour récupéré son level
        player_level = player.get("level")
        if choix == 1 and int(player_level) >= int(ghost_level): # Si il veu etre ghost et si il a le level on le met ghost
            self.ghost() 
            popuplib.send("menuGhoster", self.userid) # Renvoi du menu
        elif int(player_level) < int(ghost_level): # Sinon on lui envoi un message
            joueur = playerlib.getPlayer(self.userid)
            es.tell(self.userid, "#multi",sw_langue("ghost_not_level",lang=player.get("lang")))
        if choix == 2 and int(player_level) >= int(unghost_level): # Si il veu etre unghost et si il a le level on le met unghost
            self.unghost()
            popuplib.send("menuGhoster", self.userid)
        elif int(player_level) < int(unghost_level): # Sinon petit message
            joueur = playerlib.getPlayer(self.userid)
            es.tell(self.userid, "#multi", sw_langue("unghost_not_level",lang=player.get("lang")))
        if choix == 8: # Renvoi du menu principale
            popuplib.send("menuSorrow", self.userid)
    def send_menu(self):
        popuplib.send("menuGhoster", self.userid) # Envoi du menu