# -*- coding:Utf-8 -*-
import es, playerlib, langlib, popuplib
import sw_config as swConfig
import sw_player as swPlayer

## Ouverture du fichier de langue
sw_langue = langlib.Strings(es.getAddonPath("sorrow") + "/configuration/langues.ini")

# Dictionnaire qui contient toutes les armes
weapon_list = {"weapon_ak47" : "primary", "weapon_aug" : "primary", "weapon_awp" : "primary", "weapon_deagle" : "secondary", "weapon_elite" : "secondary", "weapon_famas" : "primary",
               "weapon_fiveseven" : "secondary", "weapon_galil" : "primary", "weapon_g3sg1" : "primary", "weapon_glock" : "secondary",
               "weapon_m249" : "primary", "weapon_m3" : "primary", "weapon_m4a1" : "primary", "weapon_mac10" : "primary", "weapon_mp5navy" : "primary",
               "weapon_p228" : "secondary", "weapon_p90" : "primary", "weapon_scout" : "primary", "weapon_sg550" : "primary",
               "weapon_sg552" : "primary", "weapon_tmp" : "primary", "weapon_ump45" : "primary", "weapon_usp" : "secondary", "weapon_xm1014" : "primary", "weapon_flashbang" : "grenade"}
weapon_name = {"weapon_ak47" : "CV-47", "weapon_aug" : "Bullpup", "weapon_awp" : "Magnum Sniper Rifle", "weapon_deagle" : "Night Hawk .50C", "weapon_elite" : ".40 Dual Elites", "weapon_famas" : "Clarion 5.56",
               "weapon_fiveseven" : "ES Five-Seven", "weapon_galil" : "IDF Defender", "weapon_g3sg1" : "D3/AU1", "weapon_glock" : "9x19mm Sidearm",
               "weapon_m249" : "M249", "weapon_m3" : "Leone 12 Gauge Super", "weapon_m4a1" : "Maverick M4A1 Carbine", "weapon_mac10" : "Ingram MAC-10", "weapon_mp5navy" : "KM Sub-Machine Gun",
               "weapon_p228" : "228 Compact", "weapon_p90" : "ES C90", "weapon_scout" : "Schmidt Scout", "weapon_sg550" : "Krieg 550 Commando",
               "weapon_sg552" : "Krieg 552", "weapon_tmp" : "Schmidt Machine Pistol", "weapon_ump45" : "KM UMP45", "weapon_usp" : "KM .45 Tactical", "weapon_xm1014" : "Leone YG1265 Auto Shotgun", "weapon_flashbang" : "FlashBang"}

class Weapon:
    def __init__(self, userid):
        self.weapon_player = [] # Liste qui va contenir les armes que le joueurs peut utiliser
        self.weapon_choice = {} # Dico qui va contenir les armes et leur place dans le menu
        self.weapon_popupid = {} # Dico qui va contenir les armes et leur numéro de page
        self.userid = userid
        self.steamid = es.getplayersteamid(userid)
        module = swConfig.Config("modules") # récupére les configuration du fichier modules.ini
        player = swPlayer.Player(userid) # instantiation du joueur pour récupéré ses infos
        player_level = player.get("level") # récupére son level
        # Création de la liste des armes que le joueur peu utilisé par rapport à son level
        for clef in weapon_list:
            weapon_level = module.get("ModuleWeapon", clef) # Récupération du level du joueur
            # Si il a le level
            if int(player_level) >= int(weapon_level):
                self.weapon_player.append(clef) # on ajoute l'arme à la list
        self.create_menu() # Création du menu
    def give(self, weapon):
        # Fonction qui me sert à donné une arme
        joueur = playerlib.getPlayer(self.userid) # instantiation du joueur dans la playerlib
        playerDead = joueur.get("isdead") # Vérifie si il n'est pas mort
        if playerDead == 0:
            if weapon_list[weapon] == "primary": # Arme primaire
                es.server.cmd("est_removeweapon %s 1"%(self.userid)) # On lui enleve
                es.server.cmd("es_give %s %s"%(self.userid,weapon)) # On lui donne
                joueur.set("ammo", ["primary", "0"]) # On lui met les munitions à zéro
                joueur.set("clip", ["primary", "0"])
            elif weapon_list[weapon] == "secondary":
                es.server.cmd("est_removeweapon %s 2"%(self.userid))
                es.server.cmd("es_give %s %s"%(self.userid,weapon))
                joueur.set("ammo", ["secondary", "0"])
                joueur.set("clip", ["secondary", "0"])
            elif weapon_list[weapon] == "grenade":
                es.server.cmd("est_removeweapon %s 4"%(self.userid))
                es.server.cmd("es_give %s %s"%(self.userid,weapon))
            es.sexec(self.userid, "use %s"%(weapon)) # On le force à utilisé l'arme qu'il a choisi
    def create_menu(self):
        max_choice = 1 # variable qui sert a vérifier si il y a plus de 7 armes dans le menu
        total_choice = 0 # variable qui sert a vérifier si le total des choix n'est pas plus grands que la taille de la list d'armes
        popup_num = 1 # variable qui sert a compter le nombre de page
        menuwp = popuplib.create('menuWeapon-%s_%s'%(self.userid,popup_num)) # Création du menu 
        menuwp.addline("(      [Sorrow]      )") # Titre
        menuwp.addline("-------- Menu Weapon --------(Page : %s)"%(popup_num))
        # boucle sur chaque clef de la list self.weapon_player (armes que le joueur peu utiliser par rapport à son level)
        for clef in self.weapon_player:
            self.weapon_choice[clef] = max_choice # stock dans le dico self.weapon_choice, l'arme et sa place dans le menu -- clef = nom de l'arme
            self.weapon_popupid[clef] = popup_num # stock l'arme et son numéro de page (Pour savoir ensuite quelle choix c'est par rapport à la page)
            menuwp.addline("->%s. %s"%(self.weapon_choice[clef], weapon_name[clef])) # Ajout de la ligne
            max_choice += 1 # Incrémente le max_choice de 1
            total_choice += 1 # Incrémente le total_choice de 1
            if max_choice == 8 or total_choice == len(self.weapon_player): # Si le nombre de choix est égale à 8 ou que le total de tout les choix de toutes les pages est plus grands que ceux de la listes
                menuwp.addline("------------------") # On termine le menu
                menuwp.addline("->8. Retour")
                max_choice = 1 # Remet max_choice à 1 pour repartir sur un autre menu si il reste des armes à ajouter
                if total_choice != len(self.weapon_player) and total_choice < len(self.weapon_player): # Si le nombre total d'arme mis dans le menu n'est pas égale à la taille de la liste et qu'il n'est pas supérieur
                    popup_num += 1 # On incrément de 1 popup_num pour une prochaine page
                    menuwp.addline("->9. Suivant") # On termine le menu
                    menuwp.addline("->0. Sortir")
                    menuwp.menuselect = self.choix_menu
                    menuwp = popuplib.create('menuWeapon-%s_%s'%(self.userid,popup_num)) # On créer le prochain
                    menuwp.addline("(      [Sorrow]      )")
                    menuwp.addline("-------- Menu Weapon --------(Page : %s)"%(popup_num))
                else:
                    menuwp.addline("->0. Sortir") # Par contre si on a attein le total on fini le dernier menu
                    menuwp.menuselect = self.choix_menu
    def send_menu(self):
        popuplib.send('menuWeapon-%s_1'%(self.userid), self.userid) # Envoi la premiére page
    def choix_menu(self, userid, choix, popupid):
        id_popup = popupid.split("_") # Récupére le numéro de la page
        if choix != 8 and choix != 9 and choix != 10: # Si le choix n'est pas 8 - 9 ou 10 (qui sont des choix spéciaux)
            for clef in self.weapon_choice: # Alors je boucle sur ma liste d'arme avec leur choix
                if int(choix) == int(self.weapon_choice[clef]) and int(id_popup[1]) == int(self.weapon_popupid[clef]): # Si le choix est égale à une clef de mon dico et que le numéro de la page est égale à la meme clef de mon autre dico
                    self.give(clef) # Je donne l'arme au joueur
            popuplib.send(popupid, userid) # Et lui renvoi la page
        elif choix == 9: # Si le choix est 9 (donc suivant)
            next_page = int(id_popup[1]) + 1 # Incrément de 1 pour lui envoyé la prochaine page
            next_page_exists = False # Bool qui me sert à savoir si c'est pas la fin du menu
            for clef in self.weapon_popupid: # Boucle sur chaque arme et son numéro de page
                if self.weapon_popupid[clef] == next_page: # Si une arme à ce numéro de page alors je change le bool en True
                    next_page_exists = True
                    break # Sort de ma boucle
            if next_page_exists == True: # Donc si la page existe
                popuplib.send("menuWeapon-%s_%s"%(self.userid,next_page), userid) # Je lui envoi
            else:
                popuplib.send(popupid, userid) # Sinon je lui renvoi la meme page
        elif choix == 8: # Si le choix est 8 (donc précédent)
            previous_page = int(id_popup[1]) - 1 # Décrémente de 1 (pour lui renvoyé la page précédente)
            if previous_page != 0: # Si le numéro de la page n'est pas 0
                previous_page_exists = False # Bool qui me sert à vérifié si la page existe
                for clef in self.weapon_popupid: # Boucle sur chaque arme et son numéro de page
                    if self.weapon_popupid[clef] == previous_page: # Si une arme et son numéro correspon je change le bool
                        previous_page_exists = True
                if previous_page_exists == True: # Donc je lui envoi le menu
                    popuplib.send("menuWeapon-%s_%s"%(self.userid,previous_page), userid)
            else: # Si le numéro de page est 0 (donc plus de menu précédent)
                popuplib.send("menuSorrow", userid) # je lui envoi le menu principal sorrow